"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _zeromq = _interopRequireDefault(require("zeromq"));
var _configureStore = _interopRequireDefault(require("./store/configureStore"));
var zmqServices = _interopRequireWildcard(require("./actions/zmqServices"));
var _zmqServices2 = require("./selectors/zmqServices");
var _configYml = _interopRequireDefault(require("config-yml"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var init_services = _configYml["default"].discovery.services;
var zmq_in = _zeromq["default"].socket("rep");
var zmq_out = _zeromq["default"].socket("pub");
var url_in = "tcp://*:" + _configYml["default"].discovery.input.port;
var url_out = "tcp://*:" + _configYml["default"].discovery.publish.port;
console.log('Discovery is waiting for connection at "' + url_in);
zmq_in.bindSync(url_in);
zmq_out.bindSync(url_out);
if (init_services !== undefined) {
  console.log("Default services: ");
  init_services.forEach(function (element) {
    console.log(element);
    _configureStore["default"].dispatch(zmqServices.onZeroMQServiceAdd(element));
    zmq_out.send(JSON.stringify({
      action: "add",
      zmq: element
    }));
  });
}
zmq_in.on("message", function (a, n, u, s, c) {
  var action = a.toString();
  var name = n.toString();
  var url = u.toString();
  var src = s.toString();
  var cache = c;
  if (action === "add") {
    if (name.length !== 0) {
      var out = {
        name: name,
        url: url,
        src: src,
        cache: cache
      };
      _configureStore["default"].dispatch(zmqServices.onZeroMQServiceAdd(out));
      // TODO to put it to store
      zmq_out.send(JSON.stringify({
        action: action,
        zmq: out
      }));
    }
    zmq_in.send(JSON.stringify({
      rc: 0,
      msg: "OK"
    }));
  } else if (action === "rm") {
    if (name.length !== 0) {
      var _out = {
        name: name,
        url: url,
        src: src,
        cache: cache
      };
      _configureStore["default"].dispatch(zmqServices.onZeroMQServiceRemove(_out));
      // TODO to put it to store
      zmq_out.send(JSON.stringify({
        action: action,
        zmq: _out
      }));
    }
    zmq_in.send(JSON.stringify({
      rc: 0,
      msg: "OK"
    }));
  } else if (action === "get") {
    // TODO to put it to store
    zmq_in.send(JSON.stringify({
      rc: 0,
      msg: "OK",
      data: (0, _zmqServices2.getZeroMQServices)(_configureStore["default"].getState()).services
    }));
  }
});
process.on("SIGINT", function () {
  console.log();
  console.log("Exiting ...");
  zmq_in.unbind(url_in);
  zmq_out.unbind(url_out);
  process.exit(1);
});