"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onZeroMQServiceRemoveSingle = exports.onZeroMQServiceRemove = exports.onZeroMQServiceAdd = exports.onWebSocketUserLogout = exports.onWebSocketUserLogin = exports.onWebSocketExit = exports.onWebSocketEnter = exports.onAppStart = void 0;
var _appInfo = require("../actionTypes/appInfo");
var _appInfo2 = require("../selectors/appInfo");
// actions

var onAppStart = exports.onAppStart = function onAppStart(data) {
  return function (dispatch) {
    dispatch({
      type: _appInfo.ON_APP_START,
      payload: data
    });
  };
};
var onWebSocketEnter = exports.onWebSocketEnter = function onWebSocketEnter(wss, userInfo) {
  return function (dispatch, getState) {
    dispatch({
      type: _appInfo.ON_WS_ENTER,
      userInfo: userInfo
    });
    wss.broadcast((0, _appInfo2.getAppInfoForWebSocket)(getState()));
  };
};
var onWebSocketExit = exports.onWebSocketExit = function onWebSocketExit(wss, userInfo) {
  return function (dispatch, getState) {
    dispatch({
      type: _appInfo.ON_WS_EXIT,
      userInfo: userInfo
    });
    wss.broadcast((0, _appInfo2.getAppInfoForWebSocket)(getState()));
  };
};
var onWebSocketUserLogin = exports.onWebSocketUserLogin = function onWebSocketUserLogin(wss, id, username, uid) {
  return function (dispatch, getState) {
    dispatch({
      type: _appInfo.ON_WS_USER_LOGIN,
      id: id,
      username: username,
      uid: uid
    });
    wss.broadcast((0, _appInfo2.getAppInfoForWebSocket)(getState()));
  };
};
var onWebSocketUserLogout = exports.onWebSocketUserLogout = function onWebSocketUserLogout(wss, id) {
  return function (dispatch, getState) {
    dispatch({
      type: _appInfo.ON_WS_USER_LOGOUT,
      id: id
    });
    wss.broadcast((0, _appInfo2.getAppInfoForWebSocket)(getState()));
  };
};
var onZeroMQServiceAdd = exports.onZeroMQServiceAdd = function onZeroMQServiceAdd(data, wss) {
  return function (dispatch, getState) {
    dispatch({
      type: _appInfo.ON_SERVICE_ADD,
      payload: data,
      wss: wss
    });
    wss.broadcast((0, _appInfo2.getAppInfoForWebSocket)(getState()));
  };
};
var onZeroMQServiceRemove = exports.onZeroMQServiceRemove = function onZeroMQServiceRemove(data, wss) {
  return function (dispatch, getState) {
    dispatch({
      type: _appInfo.ON_SERVICE_REMOVE_BY_GROUP,
      payload: data,
      wss: wss
    });
    wss.broadcast((0, _appInfo2.getAppInfoForWebSocket)(getState()));
  };
};
var onZeroMQServiceRemoveSingle = exports.onZeroMQServiceRemoveSingle = function onZeroMQServiceRemoveSingle(data, wss) {
  return function (dispatch, getState) {
    dispatch({
      type: _appInfo.ON_SERVICE_REMOVE_SINGLE,
      payload: data,
      wss: wss
    });
    wss.broadcast((0, _appInfo2.getAppInfoForWebSocket)(getState()));
  };
};