"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onWebSocketUnSub = exports.onWebSocketSub = void 0;
var _ws = _interopRequireDefault(require("ws"));
var _wsBroker = require("../actionTypes/wsBroker");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var onWebSocketSub = exports.onWebSocketSub = function onWebSocketSub(ws, zmq$, name) {
  return function (dispatch, getState) {
    var state = getState();
    var zmqUnSub = zmq$.subscribe(function (payload) {
      if (ws.readyState === _ws["default"].OPEN) {
        ws.send(JSON.stringify({
          type: "zmq",
          src: name.substring(0, name.indexOf("|")),
          payload: payload
        }));
      } else {
        zmqUnSub.unsubscribe();
        zmqUnSub = null;
      }
    });
    dispatch({
      type: _wsBroker.ON_WS_BROKER_SUB,
      name: name,
      zmqUnSub: zmqUnSub,
      ws: ws
    });
  };
};
var onWebSocketUnSub = exports.onWebSocketUnSub = function onWebSocketUnSub(ws, name) {
  return function (dispatch, getState) {
    var state = getState();
    dispatch({
      type: _wsBroker.ON_WS_BROKER_UNSUB,
      name: name,
      ws: ws
    });
  };
};