"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onZeroMQSubRemoveByGroup = exports.onZeroMQSubRemoveByFullName = exports.onZeroMQSubCleanup = exports.onZeroMQSubAdd = exports.onZeroMQRemove = exports.onZeroMQAdd = void 0;
var _zeromq = _interopRequireDefault(require("zeromq"));
var _rxjs = _interopRequireDefault(require("rxjs"));
var zmqBroker = _interopRequireWildcard(require("../actions/zmqBroker"));
var appInfo = _interopRequireWildcard(require("../actions/appInfo"));
var _zmqBroker2 = require("../actionTypes/zmqBroker");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var onZeroMQAdd = exports.onZeroMQAdd = function onZeroMQAdd(data, wss) {
  return function (dispatch, getState) {
    var state = getState();

    // TODO If we already have that name
    var zmq_sock = _zeromq["default"].socket("sub");
    zmq_sock.connect(data.url);
    zmq_sock.subscribe("");
    dispatch({
      type: _zmqBroker2.ON_ZMQ_BROKER_ADD,
      payload: data,
      zmq: zmq_sock
    });
    zmq_sock.on("message", function (sub, name, d) {
      //    console.log("zmq : '" + sub.toString() + "' '" + name.toString() + "'");

      var state = getState();
      var sub_str = sub.toString();
      var src = sub_str.substring(0, sub_str.indexOf(":"));
      if (src === "") src = "obmon";
      var n = src + "|" + data.name + "|" + name.toString();
      // FIXME IF ZMQ service is removed
      if (state.zmqBroker.zmqs$[n] === undefined) {
        // console.log(data)
        dispatch(zmqBroker.onZeroMQSubAdd({
          name: data.name,
          sub: name.toString(),
          src: src.toString(),
          cache: data.cache || 1
        }));
        dispatch(appInfo.onZeroMQServiceAdd({
          name: data.name,
          sub: name.toString(),
          src: src.toString()
        }, wss));
      }
      if (state.zmqBroker.zmqs$[n] !== undefined) {
        var r$ = state.zmqBroker.zmqs$[n].zmq$;
        if (r$ !== undefined) {
          var out = {
            name: data.name,
            sub: name.toString(),
            data: JSON.parse(d.toString())
          };
          r$.next(out);
        }
      }
    });
  };
};
var onZeroMQRemove = exports.onZeroMQRemove = function onZeroMQRemove(data, wss) {
  return function (dispatch, getState) {
    var state = getState();
    if (state.zmqBroker.zmqs === undefined) {
      return;
    }
    var z = state.zmqBroker.zmqs[data.name];
    if (z === undefined) {
      return;
    }
    z.zmq.disconnect(z.url);
    delete z.zmq;
    dispatch(appInfo.onZeroMQServiceRemove({
      name: data.name,
      sub: ""
    }, wss));
    dispatch({
      type: _zmqBroker2.ON_ZMQ_BROKER_REMOVE,
      payload: data
    });
  };
};
var onZeroMQSubAdd = exports.onZeroMQSubAdd = function onZeroMQSubAdd(data) {
  return function (dispatch, getState) {
    var state = getState();
    dispatch({
      type: _zmqBroker2.ON_ZMQ_BROKER_ZMQSUB_ADD,
      payload: data,
      zmq$: new _rxjs["default"].ReplaySubject(data.cache || 1)
    });
  };
};
var onZeroMQSubRemoveByGroup = exports.onZeroMQSubRemoveByGroup = function onZeroMQSubRemoveByGroup(data) {
  return function (dispatch, getState) {
    var state = getState();
    dispatch({
      type: _zmqBroker2.ON_ZMQ_BROKER_ZMQSUB_REMOVE_BY_GROUP,
      payload: data
    });
  };
};
var onZeroMQSubRemoveByFullName = exports.onZeroMQSubRemoveByFullName = function onZeroMQSubRemoveByFullName(data) {
  return function (dispatch, getState) {
    var state = getState();
    dispatch({
      type: _zmqBroker2.ON_ZMQ_BROKER_ZMQSUB_REMOVE_BY_FULLNAME,
      payload: data
    });
  };
};
var onZeroMQSubCleanup = exports.onZeroMQSubCleanup = function onZeroMQSubCleanup(timeout, wss) {
  return function (dispatch, getState) {
    var d = new Date();
    d.setSeconds(d.getSeconds() - timeout);
    var state = getState();
    // console.log("Checking cleanup ...");

    for (var key in state.zmqBroker.zmqs$) {
      var obj = state.zmqBroker.zmqs$[key];
      // console.log(key);
      // console.log(obj.zmq$._events.length);
      if (obj.zmq$._events.length > 0) {
        // console.log(d.getTime());
        // console.log(obj.zmq$._events[0].time);
        var diff = d.getTime() - obj.zmq$._events[0].time;
        // console.log("key : " + key + " diff : " + diff);
        if (diff > 0) {
          var res = key.split("|");
          console.log("Removing inactive service (more then " + timeout + " sec) : name=" + res[1] + " sub=" + res[2] + " src=" + res[0] + "...");
          dispatch(zmqBroker.onZeroMQSubRemoveByFullName({
            name: key
          }));
          dispatch(appInfo.onZeroMQServiceRemoveSingle({
            name: res[1],
            sub: res[2],
            src: res[0]
          }, wss));
          // sending empty data to signal frontend that service is not active anymore
          wss.broadcast(JSON.stringify({
            type: "zmq",
            data: [],
            name: res[1],
            sub: res[2],
            src: res[0]
          }));
        }
      }
    }
  };
};