"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _child_process = require("child_process");
var _package = require("../../package.json");
var _configYml = _interopRequireDefault(require("config-yml"));
var _server = _interopRequireDefault(require("./server"));
var _zeromq = _interopRequireDefault(require("zeromq"));
var _configureStore = _interopRequireDefault(require("./store/configureStore"));
var appInfo = _interopRequireWildcard(require("./actions/appInfo"));
var zmqBroker = _interopRequireWildcard(require("./actions/zmqBroker"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
console.log(_package.name + " " + _package.version);
var url_init = "tcp://" + _configYml["default"].discovery.input.host + ":" + _configYml["default"].discovery.input.port;
var url_publisher = "tcp://" + _configYml["default"].discovery.publish.host + ":" + _configYml["default"].discovery.publish.port;
var zmq_discovery_init = _zeromq["default"].socket("req");
var zmq_discovery = _zeromq["default"].socket("sub");
if (url_init !== undefined && url_init !== 0) {
  console.log("ZMQ connected to " + url_init);
  zmq_discovery_init.connect(url_init);
  zmq_discovery_init.send(["get", "", "", ""]);
  zmq_discovery_init.on("message", function (data) {
    var dataObj = JSON.parse(data.toString());
    dataObj.data.forEach(function (item) {
      console.log(item);
      _configureStore["default"].dispatch(zmqBroker.onZeroMQAdd(item, _server["default"].wss));
    });
    zmq_discovery_init.disconnect(url_init);
  });
}
if (url_publisher !== undefined && url_publisher.length !== 0) {
  console.log("ZMQ connected to " + url_publisher + " sub='" + _configYml["default"].discovery.publish.sub + "'");
  zmq_discovery.connect(url_publisher);
  zmq_discovery.subscribe(_configYml["default"].discovery.publish.sub);
  zmq_discovery.on("message", function (data) {
    var dataObj = JSON.parse(data.toString());
    console.log(dataObj);
    if (dataObj.action === "add") {
      _configureStore["default"].dispatch(zmqBroker.onZeroMQAdd(dataObj.zmq, _server["default"].wss));
    } else if (dataObj.action === "rm") {
      _configureStore["default"].dispatch(zmqBroker.onZeroMQSubRemoveByGroup(dataObj.zmq));
      _configureStore["default"].dispatch(zmqBroker.onZeroMQRemove(dataObj.zmq, _server["default"].wss));
    } else {
      console.log("Error : [zmq_discovery] unknown type=" + dataObj.type);
    }
  });
}
var myVar = setInterval(myTimer, process.env.ZMQ2WS_INACTIVITY_CHECK_MSEC || 60 * 1000 /** 1 min */);
function myTimer() {
  _configureStore["default"].dispatch(zmqBroker.onZeroMQSubCleanup(process.env.ZMQ2WS_INACTIVITY_TIMEOUT_SEC || 3600 /** 1 hour */, _server["default"].wss));
}
_configureStore["default"].dispatch(appInfo.onAppStart({
  name: _package.name,
  version: _package.version
}));
_server["default"].server.listen(_server["default"].get("port"), function () {
  return console.log("Http" + (_configYml["default"].zmq2ws.ssl.enabled ? "s" : "") + " is listening on port " + _server["default"].get("port"));
});
process.on("SIGINT", function () {
  console.log();
  console.log("Exiting ...");
  zmq_discovery.unsubscribe(_configYml["default"].discovery.publish.sub);
  zmq_discovery.unbind(url_publisher);
  process.exit(1);
});