"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = reducer;
var _appInfo = require("../actionTypes/appInfo");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
// init state
var initialState = {
  name: "",
  version: "",
  clients: [],
  services: []
};

// reducer
function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;
  var clients = [];
  var clientArray = [];
  var userIndex = 0;
  var services = [];
  switch (action.type) {
    case _appInfo.ON_APP_START:
      var _action$payload = action.payload,
        name = _action$payload.name,
        version = _action$payload.version;
      console.log("Starting '" + name + " " + version + "' ...");
      return _objectSpread(_objectSpread({}, state), {}, {
        name: name,
        version: version
      });
    case _appInfo.ON_WS_ENTER:
      clients = _toConsumableArray(state.clients);
      clientArray = clients.map(function (item) {
        return item.id;
      });
      userIndex = clientArray.indexOf(action.userInfo.id);
      if (userIndex === -1) {
        return _objectSpread(_objectSpread({}, state), {}, {
          clients: [].concat(_toConsumableArray(clients), [action.userInfo])
        });
      }
      console.log("Error: in redusers/appInfo. This should not happen");
      return state;
    case _appInfo.ON_WS_USER_LOGIN:
      clients = _toConsumableArray(state.clients);
      clientArray = clients.map(function (item) {
        return item.id;
      });
      userIndex = clientArray.indexOf(action.id);
      if (userIndex !== -1) {
        clients[userIndex]["username"] = action.username;
        clients[userIndex]["uid"] = action.uid;
        return _objectSpread(_objectSpread({}, state), {}, {
          clients: clients
        });
      }
      return state;
    case _appInfo.ON_WS_USER_LOGOUT:
      clients = _toConsumableArray(state.clients);
      clientArray = clients.map(function (item) {
        return item.id;
      });
      userIndex = clientArray.indexOf(action.id);
      if (userIndex !== -1) {
        clients[userIndex].userInfo.username = "";
        return _objectSpread(_objectSpread({}, state), {}, {
          clients: clients
        });
      }
      return state;
    case _appInfo.ON_WS_EXIT:
      clients = _toConsumableArray(state.clients);
      clients = clients.filter(function (item) {
        return item.id !== action.userInfo.id;
      });
      return _objectSpread(_objectSpread({}, state), {}, {
        clients: clients
      });
    case _appInfo.ON_SERVICE_ADD:
      services = _toConsumableArray(state.services);
      services = services.filter(function (item) {
        return item.name === action.payload.name && item.sub === action.payload.sub && item.src === action.payload.src;
      });
      if (services.length === 0) return _objectSpread(_objectSpread({}, state), {}, {
        services: [].concat(_toConsumableArray(state.services), [{
          name: action.payload.name,
          sub: action.payload.sub,
          src: action.payload.src
        }])
      });
      return state;
    case _appInfo.ON_SERVICE_REMOVE_BY_GROUP:
      services = _toConsumableArray(state.services);
      services = services.filter(function (item) {
        return item.name !== action.payload.name;
      });
      return _objectSpread(_objectSpread({}, state), {}, {
        services: services
      });
    case _appInfo.ON_SERVICE_REMOVE_SINGLE:
      services = _toConsumableArray(state.services);
      services = services.filter(function (item) {
        return !(item.name === action.payload.name && item.sub === action.payload.sub && item.src === action.payload.src);
      });
      return _objectSpread(_objectSpread({}, state), {}, {
        services: services
      });
    default:
      return state;
  }
}