"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = reducer;
var _ws = _interopRequireDefault(require("ws"));
var _wsBroker = require("../actionTypes/wsBroker");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
// init state
var initialState = {
  wsClients: {}
};

// reducer
function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case _wsBroker.ON_WS_BROKER_SUB:
      {
        // TODO check if subscribed already
        var clients = _objectSpread({}, state.wsClients);
        if (clients[action.ws.id] !== undefined) {
          if (clients[action.ws.id][action.name] !== undefined) {
            clients[action.ws.id][action.name].unsubscribe();
            delete clients[action.ws.id][action.name];
          }
        } else {
          clients[action.ws.id] = {};
        }
        clients[action.ws.id][action.name] = action.zmqUnSub;
        return _objectSpread(_objectSpread({}, state), {}, {
          wsClients: clients
        });
      }
    case _wsBroker.ON_WS_BROKER_UNSUB:
      {
        if (state.wsClients[action.ws.id] === undefined) {
          return state;
        }
        var _clients = _objectSpread({}, state.wsClients);
        if (action.name === "") {
          for (var o in _clients[action.ws.id]) {
            if (_clients[action.ws.id].hasOwnProperty(o)) {
              // TODO move it to action
              _clients[action.ws.id][o].unsubscribe();
              delete _clients[action.ws.id][o];
            }
          }
        } else {
          if (_clients[action.ws.id][action.name] !== undefined) {
            // TODO move it to action
            _clients[action.ws.id][action.name].unsubscribe();
            delete _clients[action.ws.id][action.name];
          }
        }
        if (Object.keys(_clients[action.ws.id]).length === 0 && _clients[action.ws.id].constructor === Object) {
          delete _clients[action.ws.id];
        }
        return _objectSpread(_objectSpread({}, state), {}, {
          wsClients: _clients
        });
      }
    default:
      return state;
  }
}