"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = reducer;
var _zmqBroker = require("../actionTypes/zmqBroker");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure " + obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var initialState = {
  zmqs: {},
  zmqs$: {}
};
function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case _zmqBroker.ON_ZMQ_BROKER_ADD:
      // console.log(action.zmq);
      return _objectSpread(_objectSpread({}, state), {}, {
        zmqs: _objectSpread(_objectSpread({}, state.zmqs), {}, _defineProperty({}, action.payload.name, {
          zmq: action.zmq,
          url: action.payload.url
        }))
      });
    case _zmqBroker.ON_ZMQ_BROKER_REMOVE:
      return _objectSpread(_objectSpread({}, state), {}, {
        zmqs: _objectSpread(_objectSpread({}, state.zmqs), {}, _defineProperty({}, action.payload.name, undefined))
      });
    case _zmqBroker.ON_ZMQ_BROKER_ZMQSUB_ADD:
      return _objectSpread(_objectSpread({}, state), {}, {
        zmqs$: _objectSpread(_objectSpread({}, state.zmqs$), {}, _defineProperty({}, action.payload.src + "|" + action.payload.name + "|" + action.payload.sub, {
          zmq$: action.zmq$,
          name: action.payload.name
        }))
      });
    case _zmqBroker.ON_ZMQ_BROKER_ZMQSUB_REMOVE_BY_GROUP:
      var clone = _extends({}, (_objectDestructuringEmpty(state.zmqs$), state.zmqs$));
      for (var p in clone) {
        if (clone.hasOwnProperty(p)) {
          if (p.startsWith(action.payload.src + "|" + action.payload.name)) {
            delete clone[p];
          }
        }
      }
      return _objectSpread(_objectSpread({}, state), {}, {
        zmqs$: clone
      });
    case _zmqBroker.ON_ZMQ_BROKER_ZMQSUB_REMOVE_BY_FULLNAME:
      var clone_byname = _extends({}, (_objectDestructuringEmpty(state.zmqs$), state.zmqs$));
      for (var p in clone_byname) {
        if (clone_byname.hasOwnProperty(p)) {
          if (p === action.payload.name) {
            delete clone_byname[p];
          }
        }
      }
      return _objectSpread(_objectSpread({}, state), {}, {
        zmqs$: clone_byname
      });
    default:
      return state;
  }
}