"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _redux = require("redux");
var _reduxThunk = _interopRequireDefault(require("redux-thunk"));
var _reduxCliLogger = _interopRequireDefault(require("redux-cli-logger"));
var _appInfo = _interopRequireDefault(require("../reducers/appInfo"));
var _zmqBroker = _interopRequireDefault(require("../reducers/zmqBroker"));
var _wsBroker = _interopRequireDefault(require("../reducers/wsBroker"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var reducer = (0, _redux.combineReducers)({
  appInfo: _appInfo["default"],
  zmqBroker: _zmqBroker["default"],
  wsBroker: _wsBroker["default"]
});
var middleware = [_reduxThunk["default"]
// your middleware here
];
if (process.env.NODE_ENV === 'development') {
  console.log("Development mode is enabled");
  var loggerOptions = {};
  var logger = (0, _reduxCliLogger["default"])(loggerOptions);
  middleware.push(logger);
}
var enhancer = (0, _redux.compose)(_redux.applyMiddleware.apply(void 0, middleware)
// optionally, electron-enhancer, redux-loop, etc.
);
var configureStore = function configureStore(initialState) {
  return (0, _redux.createStore)(reducer, initialState, enhancer);
};
var store = configureStore();
var _default = exports["default"] = store;