"use strict";

var _zeromq = _interopRequireDefault(require("zeromq"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var zmq_sock = _zeromq["default"].socket("pub");
function help() {
  console.log(process.argv[0] + " " + process.argv[1] + " <zmq-url> <cmd>");
}
var i = 0;
if (process.argv.length < 3) {
  help();
  process.exit(1);
} else {
  var url = process.argv[2] || "tcp://localhost:41000";
  ;
  var cmd = process.argv[3] || "WORKER_COUNT";
  var zmq_dealer = _zeromq["default"].socket('dealer');
  console.log("ZMQ connected to " + url);
  zmq_dealer.connect(url);
  console.log(cmd);
  // process.exit(0);
  //   zmq_dealer.send(["", "AUTH"]);
  zmq_dealer.send(["AUTH"]);
  zmq_dealer.on('message', function (empty, c, r) {
    console.log("msg is here");
    var c_str = c.toString();
    var r_str = r.toString();
    console.log(c_str);
    console.log(r_str);
    if (c_str === "AUTH" && r_str === "OK") {
      console.log("AUTH is OK");
      if (cmd !== "AUTH") {
        zmq_dealer.send([cmd]);
      }
      console.log(cmd + " sent");
    } else if (c_str === cmd && r_str === "OK") {
      console.log(cmd + " is OK");
      zmq_dealer.disconnect(url);
      process.exit(0);
    } else {
      zmq_dealer.disconnect(url);
      process.exit(0);
    }
  });
}
process.on("SIGINT", function () {
  console.log();
  console.log("Exiting ...");
  process.exit(1);
});